/* tslint:disable */
/* eslint-disable */
/**
 * EntryPoints
 * ## Overview  EntryPoint is one of the ways to start interaction flow. It can be represented as QR code, link (https://slace.me/... URL) or NFC tag.  ## Data  EntryPoints contain two types of data:   - **static** - *\"internal\" data storage which can be updated only via editing the EntryPoint* (directly or via Interaction) - **dynamic** - *public data which can be altered also via query parameters of the EP link. Should NOT be used for secrets or critical data* because it can be overwritten by the end user.  Both data containers are copied to transaction created when EntryPoint is entered. This data is used primarily for personalization or flow control of the Interaction.  ## EP Batches  EntryPoints can be batch-created (superadmin feature) and then [assigned](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx) to specific Interactions.  > EntryPoints in a batch have random hashes but it\'s possible to mass-create EPs using the assignment feature (only superadmins). If a value from **Link hash** column is not found it will be auto-created. This allows to create EntryPoints following different hash pattern (e.g. with common prefix).  EntryPoints are re-assignable meaning that they can be re-used for other Interactions even in another Channel or Organization by another [assignment import](https://slace.stoplight.io/docs/stoplight-docs-core/altekzonwbrq9-imports-uploads#assignment-xlsx).  ## Redirects  There is a special type of EntryPoint which does not start a SLACE Interaction but redirects to a configured URL.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface AdminEntryPoint
 */
export interface AdminEntryPoint {
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'id': string;
    /**
     * 
     * @type {AdminEntryPointType}
     * @memberof AdminEntryPoint
     */
    'type': AdminEntryPointType;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'organization_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'channel_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'interaction_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'message_link_hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'ordered_batch_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'url'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'url_hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'expired_url'?: string;
    /**
     * 
     * @type {number}
     * @memberof AdminEntryPoint
     */
    'ttl': number;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof AdminEntryPoint
     */
    'data'?: { [key: string]: string; };
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof AdminEntryPoint
     */
    'params'?: { [key: string]: string; };
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'created_at': string;
    /**
     * Any text without \'.\' characters. Preferred over interaction_id if keeping the reference to the latest version of interaction is required.
     * @type {string}
     * @memberof AdminEntryPoint
     */
    'customer_experience_id'?: string;
}


/**
 * 
 * @export
 * @interface AdminEntryPointMutable
 */
export interface AdminEntryPointMutable {
    /**
     * 
     * @type {AdminEntryPointType}
     * @memberof AdminEntryPointMutable
     */
    'type': AdminEntryPointType;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPointMutable
     */
    'organization_id': string;
    /**
     * required if type != external
     * @type {string}
     * @memberof AdminEntryPointMutable
     */
    'channel_id'?: string;
    /**
     * required if type == interaction
     * @type {string}
     * @memberof AdminEntryPointMutable
     */
    'interaction_id'?: string;
    /**
     * required if type == external
     * @type {string}
     * @memberof AdminEntryPointMutable
     */
    'url'?: string;
    /**
     * required if type == campaign
     * @type {string}
     * @memberof AdminEntryPointMutable
     */
    'message_link_hash'?: string;
    /**
     * Optional url to which entry point will redirect when expired
     * @type {string}
     * @memberof AdminEntryPointMutable
     */
    'expired_url'?: string;
    /**
     * time to live in seconds
     * @type {number}
     * @memberof AdminEntryPointMutable
     */
    'ttl'?: number;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof AdminEntryPointMutable
     */
    'params'?: { [key: string]: string; };
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof AdminEntryPointMutable
     */
    'data'?: { [key: string]: string; };
    /**
     * Any text without \'.\' characters. Preferred over interaction_id if keeping the reference to the latest version of interaction is required.
     * @type {string}
     * @memberof AdminEntryPointMutable
     */
    'customer_experience_id'?: string;
}


/**
 * 
 * @export
 * @interface AdminEntryPointNewData
 */
export interface AdminEntryPointNewData {
    /**
     * 
     * @type {AdminEntryPointType}
     * @memberof AdminEntryPointNewData
     */
    'type': AdminEntryPointType;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'organization_id': string;
    /**
     * required if type != external
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'channel_id'?: string;
    /**
     * required if type == interaction
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'interaction_id'?: string;
    /**
     * required if type == external
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'url'?: string;
    /**
     * required if type == campaign
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'message_link_hash'?: string;
    /**
     * Optional url to which entry point will redirect when expired
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'expired_url'?: string;
    /**
     * time to live in seconds
     * @type {number}
     * @memberof AdminEntryPointNewData
     */
    'ttl'?: number;
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof AdminEntryPointNewData
     */
    'params'?: { [key: string]: string; };
    /**
     * 
     * @type {{ [key: string]: string; }}
     * @memberof AdminEntryPointNewData
     */
    'data'?: { [key: string]: string; };
    /**
     * Any text without \'.\' characters. Preferred over interaction_id if keeping the reference to the latest version of interaction is required.
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'customer_experience_id'?: string;
    /**
     * Custom entry point hash
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof AdminEntryPointNewData
     */
    'hash_prefix'?: string;
    /**
     * 
     * @type {number}
     * @memberof AdminEntryPointNewData
     */
    'hash_length'?: number;
}


/**
 * 
 * @export
 * @enum {string}
 */

export const AdminEntryPointType = {
    Campaign: 'campaign',
    External: 'external',
    Interaction: 'interaction',
    Unknown: 'unknown'
} as const;

export type AdminEntryPointType = typeof AdminEntryPointType[keyof typeof AdminEntryPointType];


/**
 * 
 * @export
 * @interface AdminEntryPointsList
 */
export interface AdminEntryPointsList {
    /**
     * 
     * @type {Array<AdminEntryPoint>}
     * @memberof AdminEntryPointsList
     */
    'results': Array<AdminEntryPoint>;
    /**
     * 
     * @type {number}
     * @memberof AdminEntryPointsList
     */
    'total': number;
}
/**
 * 
 * @export
 * @interface BatchesJob
 */
export interface BatchesJob {
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'id'?: string;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'ordered_batch_id'?: string;
    /**
     * 
     * @type {object}
     * @memberof BatchesJob
     */
    'ordered_batch'?: object;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'media_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'type'?: BatchesJobTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'status'?: string;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'progress'?: string;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'failed_reason'?: string;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'batch_type'?: BatchesJobBatchTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'created_at'?: string;
    /**
     * 
     * @type {string}
     * @memberof BatchesJob
     */
    'updated_at'?: string;
}

export const BatchesJobTypeEnum = {
    Create: 'create',
    Resize: 'resize',
    Import: 'import',
    Assignment: 'assignment',
    FileGenerationRetry: 'file_generation_retry'
} as const;

export type BatchesJobTypeEnum = typeof BatchesJobTypeEnum[keyof typeof BatchesJobTypeEnum];
export const BatchesJobBatchTypeEnum = {
    Campaign: 'campaign',
    External: 'external',
    Interaction: 'interaction',
    Unknown: 'unknown'
} as const;

export type BatchesJobBatchTypeEnum = typeof BatchesJobBatchTypeEnum[keyof typeof BatchesJobBatchTypeEnum];

/**
 * 
 * @export
 * @interface EntryPoint
 */
export interface EntryPoint {
    /**
     * 
     * @type {EntryPointType}
     * @memberof EntryPoint
     */
    'type': EntryPointType;
    /**
     * Base64 encoded image with qr code 
     * @type {string}
     * @memberof EntryPoint
     */
    'base64_image'?: string;
    /**
     * 
     * @type {string}
     * @memberof EntryPoint
     */
    'url': string;
}


/**
 * Either `message_link_hash`, `interaction_id`, `customer_experience_id` or `redirect_url` is required.  When `type` not provided default `link` type will be used.
 * @export
 * @interface EntryPointData
 */
export interface EntryPointData {
    /**
     * 
     * @type {EntryPointType}
     * @memberof EntryPointData
     */
    'type'?: EntryPointType;
    /**
     * Custom identifier to create user friendly urls. If provided has to be unique globally. If not set unique id will be generated.
     * @type {string}
     * @memberof EntryPointData
     */
    'hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof EntryPointData
     */
    'message_link_hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof EntryPointData
     */
    'interaction_id'?: string;
    /**
     * Some external url for which short link will be created
     * @type {string}
     * @memberof EntryPointData
     */
    'redirect_url'?: string;
    /**
     * Optional url to which entry point will redirect when expired
     * @type {string}
     * @memberof EntryPointData
     */
    'expired_url'?: string;
    /**
     * Time to live in seconds
     * @type {number}
     * @memberof EntryPointData
     */
    'ttl'?: number;
    /**
     * Dynamic data ius similar to static_data but it can be also overwritten by url query parameters. This structure is then copied to contact transaction related to entry point (for example after QR code scan)
     * @type {{ [key: string]: string; }}
     * @memberof EntryPointData
     */
    'dynamic_data'?: { [key: string]: string; };
    /**
     * Custom data attached to entry point. This data is copied to every transaction when user scans and interacts messenger.
     * @type {{ [key: string]: string; }}
     * @memberof EntryPointData
     */
    'static_data'?: { [key: string]: string; };
    /**
     * Any text without \'.\' characters. Preferred over interaction_id if keeping the reference to the latest version of interaction is required.
     * @type {string}
     * @memberof EntryPointData
     */
    'customer_experience_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof EntryPointData
     */
    'channel_id'?: string;
}


/**
 * 
 * @export
 * @enum {string}
 */

export const EntryPointType = {
    Qr: 'qr',
    Nfc: 'nfc',
    Link: 'link'
} as const;

export type EntryPointType = typeof EntryPointType[keyof typeof EntryPointType];


/**
 * 
 * @export
 * @interface GenericResponse
 */
export interface GenericResponse {
    /**
     * 
     * @type {number}
     * @memberof GenericResponse
     */
    'code': number;
    /**
     * 
     * @type {string}
     * @memberof GenericResponse
     */
    'message'?: string;
    /**
     * 
     * @type {Array<GenericResponseErrors>}
     * @memberof GenericResponse
     */
    'errors'?: Array<GenericResponseErrors>;
}
/**
 * 
 * @export
 * @interface GenericResponseErrors
 */
export interface GenericResponseErrors {
    /**
     * 
     * @type {string}
     * @memberof GenericResponseErrors
     */
    'field': string;
    /**
     * 
     * @type {string}
     * @memberof GenericResponseErrors
     */
    'message'?: string;
    /**
     * 
     * @type {string}
     * @memberof GenericResponseErrors
     */
    'code'?: string;
    /**
     * 
     * @type {string}
     * @memberof GenericResponseErrors
     */
    'param'?: string;
}
/**
 * 
 * @export
 * @interface GetManagementEntryPointsJobs200Response
 */
export interface GetManagementEntryPointsJobs200Response {
    /**
     * 
     * @type {number}
     * @memberof GetManagementEntryPointsJobs200Response
     */
    'total'?: number;
    /**
     * 
     * @type {Array<BatchesJob>}
     * @memberof GetManagementEntryPointsJobs200Response
     */
    'results'?: Array<BatchesJob>;
}
/**
 * 
 * @export
 * @interface InteractionAssignmentRequest
 */
export interface InteractionAssignmentRequest {
    /**
     * 
     * @type {string}
     * @memberof InteractionAssignmentRequest
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof InteractionAssignmentRequest
     */
    'from_interaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof InteractionAssignmentRequest
     */
    'to_interaction_id': string;
}
/**
 * 
 * @export
 * @interface OrderBatchesV2Request
 */
export interface OrderBatchesV2Request {
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'type'?: OrderBatchesV2RequestTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'organization_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'channel_id'?: string;
    /**
     * 
     * @type {number}
     * @memberof OrderBatchesV2Request
     */
    'count'?: number;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'size'?: OrderBatchesV2RequestSizeEnum;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'message_link_hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'interaction_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'customer_experience_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'name'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderBatchesV2Request
     */
    'batch_id'?: string;
}

export const OrderBatchesV2RequestTypeEnum = {
    Campaign: 'campaign',
    External: 'external',
    Interaction: 'interaction',
    Unknown: 'unknown'
} as const;

export type OrderBatchesV2RequestTypeEnum = typeof OrderBatchesV2RequestTypeEnum[keyof typeof OrderBatchesV2RequestTypeEnum];
export const OrderBatchesV2RequestSizeEnum = {
    L: 'l',
    Xl: 'xl',
    Xxl: 'xxl'
} as const;

export type OrderBatchesV2RequestSizeEnum = typeof OrderBatchesV2RequestSizeEnum[keyof typeof OrderBatchesV2RequestSizeEnum];

/**
 * 
 * @export
 * @interface OrderedBatch
 */
export interface OrderedBatch {
    /**
     * 
     * @type {string}
     * @memberof OrderedBatch
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatch
     */
    'organization_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatch
     */
    'name'?: string;
    /**
     * 
     * @type {number}
     * @memberof OrderedBatch
     */
    'count': number;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatch
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatch
     */
    'updated_at': string;
}
/**
 * 
 * @export
 * @interface OrderedBatchCreateRequest
 */
export interface OrderedBatchCreateRequest {
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'type'?: OrderedBatchCreateRequestTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'organization_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'channel_id'?: string;
    /**
     * 
     * @type {number}
     * @memberof OrderedBatchCreateRequest
     */
    'count': number;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'message_link_hash'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'interaction_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'name'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'batch_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof OrderedBatchCreateRequest
     */
    'customer_experience_id'?: string;
}

export const OrderedBatchCreateRequestTypeEnum = {
    Campaign: 'campaign',
    External: 'external',
    Interaction: 'interaction',
    Unknown: 'unknown'
} as const;

export type OrderedBatchCreateRequestTypeEnum = typeof OrderedBatchCreateRequestTypeEnum[keyof typeof OrderedBatchCreateRequestTypeEnum];

/**
 * 
 * @export
 * @interface UpdateEntryPointRequest
 */
export interface UpdateEntryPointRequest {
    /**
     * 
     * @type {string}
     * @memberof UpdateEntryPointRequest
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof UpdateEntryPointRequest
     */
    'interaction_id'?: string;
    /**
     * 
     * @type {string}
     * @memberof UpdateEntryPointRequest
     */
    'message_link_hash'?: string;
    /**
     * 
     * @type {object}
     * @memberof UpdateEntryPointRequest
     */
    'dynamic_data'?: object;
    /**
     * 
     * @type {object}
     * @memberof UpdateEntryPointRequest
     */
    'static_data'?: object;
}

/**
 * BatchesJobsApi - axios parameter creator
 * @export
 */
export const BatchesJobsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get batches jobs list
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getManagementEntryPointsJobs: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/entry-points/jobs`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Retry job file generation
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsJobIdFileGenerationRetry: async (jobId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'jobId' is not null or undefined
            assertParamExists('postManagementEntryPointsJobIdFileGenerationRetry', 'jobId', jobId)
            const localVarPath = `/management/entry-points/{job_id}/file-generation-retry`
                .replace(`{${"job_id"}}`, encodeURIComponent(String(jobId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Download ordered batch file from job
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsJobsJobIdDownload: async (jobId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'jobId' is not null or undefined
            assertParamExists('postManagementEntryPointsJobsJobIdDownload', 'jobId', jobId)
            const localVarPath = `/management/entry-points/jobs/{job_id}/download`
                .replace(`{${"job_id"}}`, encodeURIComponent(String(jobId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * BatchesJobsApi - functional programming interface
 * @export
 */
export const BatchesJobsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = BatchesJobsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get batches jobs list
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getManagementEntryPointsJobs(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetManagementEntryPointsJobs200Response>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getManagementEntryPointsJobs(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Retry job file generation
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postManagementEntryPointsJobIdFileGenerationRetry(jobId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postManagementEntryPointsJobIdFileGenerationRetry(jobId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Download ordered batch file from job
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postManagementEntryPointsJobsJobIdDownload(jobId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postManagementEntryPointsJobsJobIdDownload(jobId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * BatchesJobsApi - factory interface
 * @export
 */
export const BatchesJobsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = BatchesJobsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get batches jobs list
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getManagementEntryPointsJobs(options?: any): AxiosPromise<GetManagementEntryPointsJobs200Response> {
            return localVarFp.getManagementEntryPointsJobs(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Retry job file generation
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsJobIdFileGenerationRetry(jobId: string, options?: any): AxiosPromise<void> {
            return localVarFp.postManagementEntryPointsJobIdFileGenerationRetry(jobId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Download ordered batch file from job
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsJobsJobIdDownload(jobId: string, options?: any): AxiosPromise<void> {
            return localVarFp.postManagementEntryPointsJobsJobIdDownload(jobId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * BatchesJobsApi - object-oriented interface
 * @export
 * @class BatchesJobsApi
 * @extends {BaseAPI}
 */
export class BatchesJobsApi extends BaseAPI {
    /**
     * 
     * @summary Get batches jobs list
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BatchesJobsApi
     */
    public getManagementEntryPointsJobs(options?: AxiosRequestConfig) {
        return BatchesJobsApiFp(this.configuration).getManagementEntryPointsJobs(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Retry job file generation
     * @param {string} jobId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BatchesJobsApi
     */
    public postManagementEntryPointsJobIdFileGenerationRetry(jobId: string, options?: AxiosRequestConfig) {
        return BatchesJobsApiFp(this.configuration).postManagementEntryPointsJobIdFileGenerationRetry(jobId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Download ordered batch file from job
     * @param {string} jobId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof BatchesJobsApi
     */
    public postManagementEntryPointsJobsJobIdDownload(jobId: string, options?: AxiosRequestConfig) {
        return BatchesJobsApiFp(this.configuration).postManagementEntryPointsJobsJobIdDownload(jobId, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * DefaultApi - axios parameter creator
 * @export
 */
export const DefaultApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Export pre-filtered EntryPoints
         * @param {string} [search] 
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {string} [types] 
         * @param {string} [sort] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exportEntrypoints: async (search?: string, organizationId?: string, channelId?: string, types?: string, sort?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/entry-points/export`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (search !== undefined) {
                localVarQueryParameter['search'] = search;
            }

            if (organizationId !== undefined) {
                localVarQueryParameter['organization_id'] = organizationId;
            }

            if (channelId !== undefined) {
                localVarQueryParameter['channel_id'] = channelId;
            }

            if (types !== undefined) {
                localVarQueryParameter['types[]'] = types;
            }

            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DefaultApi - functional programming interface
 * @export
 */
export const DefaultApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DefaultApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Export pre-filtered EntryPoints
         * @param {string} [search] 
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {string} [types] 
         * @param {string} [sort] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async exportEntrypoints(search?: string, organizationId?: string, channelId?: string, types?: string, sort?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.exportEntrypoints(search, organizationId, channelId, types, sort, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * DefaultApi - factory interface
 * @export
 */
export const DefaultApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DefaultApiFp(configuration)
    return {
        /**
         * 
         * @summary Export pre-filtered EntryPoints
         * @param {string} [search] 
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {string} [types] 
         * @param {string} [sort] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        exportEntrypoints(search?: string, organizationId?: string, channelId?: string, types?: string, sort?: string, options?: any): AxiosPromise<void> {
            return localVarFp.exportEntrypoints(search, organizationId, channelId, types, sort, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * DefaultApi - object-oriented interface
 * @export
 * @class DefaultApi
 * @extends {BaseAPI}
 */
export class DefaultApi extends BaseAPI {
    /**
     * 
     * @summary Export pre-filtered EntryPoints
     * @param {string} [search] 
     * @param {string} [organizationId] 
     * @param {string} [channelId] 
     * @param {string} [types] 
     * @param {string} [sort] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DefaultApi
     */
    public exportEntrypoints(search?: string, organizationId?: string, channelId?: string, types?: string, sort?: string, options?: AxiosRequestConfig) {
        return DefaultApiFp(this.configuration).exportEntrypoints(search, organizationId, channelId, types, sort, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * EntryPointsApi - axios parameter creator
 * @export
 */
export const EntryPointsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create Entry Point
         * @param {AdminEntryPointNewData} [adminEntryPointNewData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createEntryPoint: async (adminEntryPointNewData?: AdminEntryPointNewData, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/entry-points`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(adminEntryPointNewData, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create Entry Point
         * @param {string} channelId 
         * @param {EntryPointData} [entryPointData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createSimpleEntryPoint: async (channelId: string, entryPointData?: EntryPointData, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('createSimpleEntryPoint', 'channelId', channelId)
            const localVarPath = `/channels/{channel_id}/entry-points`
                .replace(`{${"channel_id"}}`, encodeURIComponent(String(channelId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(entryPointData, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete batches job with related data
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteBatchesJobWithRelatedData: async (jobId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'jobId' is not null or undefined
            assertParamExists('deleteBatchesJobWithRelatedData', 'jobId', jobId)
            const localVarPath = `/management/entry-points/jobs/{job_id}`
                .replace(`{${"job_id"}}`, encodeURIComponent(String(jobId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Entry Point
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteEntryPoint: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteEntryPoint', 'id', id)
            const localVarPath = `/management/entry-points/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Refresh batches job file
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileRefreshJob: async (jobId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'jobId' is not null or undefined
            assertParamExists('fileRefreshJob', 'jobId', jobId)
            const localVarPath = `/management/entry-points/jobs/{jobId}/file-refresh`
                .replace(`{${"jobId"}}`, encodeURIComponent(String(jobId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Entry Point
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getEntryPoint: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getEntryPoint', 'id', id)
            const localVarPath = `/management/entry-points/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List Entry Points
         * @param {string} [id] 
         * @param {string} [type] 
         * @param {Array<string>} [types] 
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {string} [orderedBatchId] 
         * @param {string} [url] 
         * @param {string} [messageLinkHash] 
         * @param {string} [interactionId] 
         * @param {string} [search] 
         * @param {number} [offset] 
         * @param {number} [limit] 
         * @param {string} [sort] 
         * @param {string} [batchesJobId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listEntryPoints: async (id?: string, type?: string, types?: Array<string>, organizationId?: string, channelId?: string, orderedBatchId?: string, url?: string, messageLinkHash?: string, interactionId?: string, search?: string, offset?: number, limit?: number, sort?: string, batchesJobId?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/entry-points`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (id !== undefined) {
                localVarQueryParameter['id'] = id;
            }

            if (type !== undefined) {
                localVarQueryParameter['type'] = type;
            }

            if (types) {
                localVarQueryParameter['types[]'] = types;
            }

            if (organizationId !== undefined) {
                localVarQueryParameter['organization_id'] = organizationId;
            }

            if (channelId !== undefined) {
                localVarQueryParameter['channel_id'] = channelId;
            }

            if (orderedBatchId !== undefined) {
                localVarQueryParameter['ordered_batch_id'] = orderedBatchId;
            }

            if (url !== undefined) {
                localVarQueryParameter['url'] = url;
            }

            if (messageLinkHash !== undefined) {
                localVarQueryParameter['message_link_hash'] = messageLinkHash;
            }

            if (interactionId !== undefined) {
                localVarQueryParameter['interaction_id'] = interactionId;
            }

            if (search !== undefined) {
                localVarQueryParameter['search'] = search;
            }

            if (offset !== undefined) {
                localVarQueryParameter['offset'] = offset;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (sort !== undefined) {
                localVarQueryParameter['sort'] = sort;
            }

            if (batchesJobId !== undefined) {
                localVarQueryParameter['batches_job_id'] = batchesJobId;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create entry point admin
         * @param {string} orgId 
         * @param {EntryPointData} [entryPointData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postEntryPointsOrgId: async (orgId: string, entryPointData?: EntryPointData, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('postEntryPointsOrgId', 'orgId', orgId)
            const localVarPath = `/entry-points/{orgId}`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(entryPointData, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Entry Point
         * @param {string} id 
         * @param {AdminEntryPointMutable} [adminEntryPointMutable] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateEntryPoint: async (id: string, adminEntryPointMutable?: AdminEntryPointMutable, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('updateEntryPoint', 'id', id)
            const localVarPath = `/management/entry-points/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(adminEntryPointMutable, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Updates entry point
         * @summary Update Entry Point
         * @param {string} channelId 
         * @param {string} id 
         * @param {UpdateEntryPointRequest} [updateEntryPointRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateExistingEntryPoint: async (channelId: string, id: string, updateEntryPointRequest?: UpdateEntryPointRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('updateExistingEntryPoint', 'channelId', channelId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('updateExistingEntryPoint', 'id', id)
            const localVarPath = `/channels/{channel_id}/entry-points/{id}`
                .replace(`{${"channel_id"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateEntryPointRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Assign entry points to another interaction
         * @summary Assign entry points to another interaction
         * @param {InteractionAssignmentRequest} [interactionAssignmentRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateInteractionAssignment: async (interactionAssignmentRequest?: InteractionAssignmentRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/entry-points/assignment/interaction`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(interactionAssignmentRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * EntryPointsApi - functional programming interface
 * @export
 */
export const EntryPointsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = EntryPointsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Create Entry Point
         * @param {AdminEntryPointNewData} [adminEntryPointNewData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createEntryPoint(adminEntryPointNewData?: AdminEntryPointNewData, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AdminEntryPoint>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createEntryPoint(adminEntryPointNewData, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create Entry Point
         * @param {string} channelId 
         * @param {EntryPointData} [entryPointData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createSimpleEntryPoint(channelId: string, entryPointData?: EntryPointData, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntryPoint>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createSimpleEntryPoint(channelId, entryPointData, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete batches job with related data
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteBatchesJobWithRelatedData(jobId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteBatchesJobWithRelatedData(jobId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Entry Point
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteEntryPoint(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GenericResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteEntryPoint(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Refresh batches job file
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async fileRefreshJob(jobId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.fileRefreshJob(jobId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Entry Point
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getEntryPoint(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AdminEntryPoint>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getEntryPoint(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List Entry Points
         * @param {string} [id] 
         * @param {string} [type] 
         * @param {Array<string>} [types] 
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {string} [orderedBatchId] 
         * @param {string} [url] 
         * @param {string} [messageLinkHash] 
         * @param {string} [interactionId] 
         * @param {string} [search] 
         * @param {number} [offset] 
         * @param {number} [limit] 
         * @param {string} [sort] 
         * @param {string} [batchesJobId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listEntryPoints(id?: string, type?: string, types?: Array<string>, organizationId?: string, channelId?: string, orderedBatchId?: string, url?: string, messageLinkHash?: string, interactionId?: string, search?: string, offset?: number, limit?: number, sort?: string, batchesJobId?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AdminEntryPointsList>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listEntryPoints(id, type, types, organizationId, channelId, orderedBatchId, url, messageLinkHash, interactionId, search, offset, limit, sort, batchesJobId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create entry point admin
         * @param {string} orgId 
         * @param {EntryPointData} [entryPointData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postEntryPointsOrgId(orgId: string, entryPointData?: EntryPointData, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntryPoint>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postEntryPointsOrgId(orgId, entryPointData, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Entry Point
         * @param {string} id 
         * @param {AdminEntryPointMutable} [adminEntryPointMutable] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateEntryPoint(id: string, adminEntryPointMutable?: AdminEntryPointMutable, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntryPoint>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateEntryPoint(id, adminEntryPointMutable, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Updates entry point
         * @summary Update Entry Point
         * @param {string} channelId 
         * @param {string} id 
         * @param {UpdateEntryPointRequest} [updateEntryPointRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateExistingEntryPoint(channelId: string, id: string, updateEntryPointRequest?: UpdateEntryPointRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntryPoint>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateExistingEntryPoint(channelId, id, updateEntryPointRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Assign entry points to another interaction
         * @summary Assign entry points to another interaction
         * @param {InteractionAssignmentRequest} [interactionAssignmentRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async updateInteractionAssignment(interactionAssignmentRequest?: InteractionAssignmentRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.updateInteractionAssignment(interactionAssignmentRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * EntryPointsApi - factory interface
 * @export
 */
export const EntryPointsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = EntryPointsApiFp(configuration)
    return {
        /**
         * 
         * @summary Create Entry Point
         * @param {AdminEntryPointNewData} [adminEntryPointNewData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createEntryPoint(adminEntryPointNewData?: AdminEntryPointNewData, options?: any): AxiosPromise<AdminEntryPoint> {
            return localVarFp.createEntryPoint(adminEntryPointNewData, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create Entry Point
         * @param {string} channelId 
         * @param {EntryPointData} [entryPointData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createSimpleEntryPoint(channelId: string, entryPointData?: EntryPointData, options?: any): AxiosPromise<EntryPoint> {
            return localVarFp.createSimpleEntryPoint(channelId, entryPointData, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete batches job with related data
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteBatchesJobWithRelatedData(jobId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteBatchesJobWithRelatedData(jobId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Entry Point
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteEntryPoint(id: string, options?: any): AxiosPromise<GenericResponse> {
            return localVarFp.deleteEntryPoint(id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Refresh batches job file
         * @param {string} jobId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        fileRefreshJob(jobId: string, options?: any): AxiosPromise<void> {
            return localVarFp.fileRefreshJob(jobId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Entry Point
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getEntryPoint(id: string, options?: any): AxiosPromise<AdminEntryPoint> {
            return localVarFp.getEntryPoint(id, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List Entry Points
         * @param {string} [id] 
         * @param {string} [type] 
         * @param {Array<string>} [types] 
         * @param {string} [organizationId] 
         * @param {string} [channelId] 
         * @param {string} [orderedBatchId] 
         * @param {string} [url] 
         * @param {string} [messageLinkHash] 
         * @param {string} [interactionId] 
         * @param {string} [search] 
         * @param {number} [offset] 
         * @param {number} [limit] 
         * @param {string} [sort] 
         * @param {string} [batchesJobId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listEntryPoints(id?: string, type?: string, types?: Array<string>, organizationId?: string, channelId?: string, orderedBatchId?: string, url?: string, messageLinkHash?: string, interactionId?: string, search?: string, offset?: number, limit?: number, sort?: string, batchesJobId?: string, options?: any): AxiosPromise<AdminEntryPointsList> {
            return localVarFp.listEntryPoints(id, type, types, organizationId, channelId, orderedBatchId, url, messageLinkHash, interactionId, search, offset, limit, sort, batchesJobId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create entry point admin
         * @param {string} orgId 
         * @param {EntryPointData} [entryPointData] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postEntryPointsOrgId(orgId: string, entryPointData?: EntryPointData, options?: any): AxiosPromise<EntryPoint> {
            return localVarFp.postEntryPointsOrgId(orgId, entryPointData, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Entry Point
         * @param {string} id 
         * @param {AdminEntryPointMutable} [adminEntryPointMutable] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateEntryPoint(id: string, adminEntryPointMutable?: AdminEntryPointMutable, options?: any): AxiosPromise<EntryPoint> {
            return localVarFp.updateEntryPoint(id, adminEntryPointMutable, options).then((request) => request(axios, basePath));
        },
        /**
         * Updates entry point
         * @summary Update Entry Point
         * @param {string} channelId 
         * @param {string} id 
         * @param {UpdateEntryPointRequest} [updateEntryPointRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateExistingEntryPoint(channelId: string, id: string, updateEntryPointRequest?: UpdateEntryPointRequest, options?: any): AxiosPromise<EntryPoint> {
            return localVarFp.updateExistingEntryPoint(channelId, id, updateEntryPointRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * Assign entry points to another interaction
         * @summary Assign entry points to another interaction
         * @param {InteractionAssignmentRequest} [interactionAssignmentRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        updateInteractionAssignment(interactionAssignmentRequest?: InteractionAssignmentRequest, options?: any): AxiosPromise<void> {
            return localVarFp.updateInteractionAssignment(interactionAssignmentRequest, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * EntryPointsApi - object-oriented interface
 * @export
 * @class EntryPointsApi
 * @extends {BaseAPI}
 */
export class EntryPointsApi extends BaseAPI {
    /**
     * 
     * @summary Create Entry Point
     * @param {AdminEntryPointNewData} [adminEntryPointNewData] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public createEntryPoint(adminEntryPointNewData?: AdminEntryPointNewData, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).createEntryPoint(adminEntryPointNewData, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create Entry Point
     * @param {string} channelId 
     * @param {EntryPointData} [entryPointData] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public createSimpleEntryPoint(channelId: string, entryPointData?: EntryPointData, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).createSimpleEntryPoint(channelId, entryPointData, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete batches job with related data
     * @param {string} jobId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public deleteBatchesJobWithRelatedData(jobId: string, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).deleteBatchesJobWithRelatedData(jobId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Entry Point
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public deleteEntryPoint(id: string, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).deleteEntryPoint(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Refresh batches job file
     * @param {string} jobId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public fileRefreshJob(jobId: string, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).fileRefreshJob(jobId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Entry Point
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public getEntryPoint(id: string, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).getEntryPoint(id, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List Entry Points
     * @param {string} [id] 
     * @param {string} [type] 
     * @param {Array<string>} [types] 
     * @param {string} [organizationId] 
     * @param {string} [channelId] 
     * @param {string} [orderedBatchId] 
     * @param {string} [url] 
     * @param {string} [messageLinkHash] 
     * @param {string} [interactionId] 
     * @param {string} [search] 
     * @param {number} [offset] 
     * @param {number} [limit] 
     * @param {string} [sort] 
     * @param {string} [batchesJobId] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public listEntryPoints(id?: string, type?: string, types?: Array<string>, organizationId?: string, channelId?: string, orderedBatchId?: string, url?: string, messageLinkHash?: string, interactionId?: string, search?: string, offset?: number, limit?: number, sort?: string, batchesJobId?: string, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).listEntryPoints(id, type, types, organizationId, channelId, orderedBatchId, url, messageLinkHash, interactionId, search, offset, limit, sort, batchesJobId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create entry point admin
     * @param {string} orgId 
     * @param {EntryPointData} [entryPointData] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public postEntryPointsOrgId(orgId: string, entryPointData?: EntryPointData, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).postEntryPointsOrgId(orgId, entryPointData, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Entry Point
     * @param {string} id 
     * @param {AdminEntryPointMutable} [adminEntryPointMutable] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public updateEntryPoint(id: string, adminEntryPointMutable?: AdminEntryPointMutable, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).updateEntryPoint(id, adminEntryPointMutable, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Updates entry point
     * @summary Update Entry Point
     * @param {string} channelId 
     * @param {string} id 
     * @param {UpdateEntryPointRequest} [updateEntryPointRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public updateExistingEntryPoint(channelId: string, id: string, updateEntryPointRequest?: UpdateEntryPointRequest, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).updateExistingEntryPoint(channelId, id, updateEntryPointRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Assign entry points to another interaction
     * @summary Assign entry points to another interaction
     * @param {InteractionAssignmentRequest} [interactionAssignmentRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EntryPointsApi
     */
    public updateInteractionAssignment(interactionAssignmentRequest?: InteractionAssignmentRequest, options?: AxiosRequestConfig) {
        return EntryPointsApiFp(this.configuration).updateInteractionAssignment(interactionAssignmentRequest, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * OrderedBatchesApi - axios parameter creator
 * @export
 */
export const OrderedBatchesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create Ordered Batch
         * @param {OrderedBatchCreateRequest} [orderedBatchCreateRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createOrderedBatch: async (orderedBatchCreateRequest?: OrderedBatchCreateRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/ordered-batch`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(orderedBatchCreateRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List Ordered Batches
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrderedBatches: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/ordered-batch`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Order batches v2
         * @param {OrderBatchesV2Request} [orderBatchesV2Request] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        orderBatchesV2: async (orderBatchesV2Request?: OrderBatchesV2Request, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/ordered-batch-v2`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(orderBatchesV2Request, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Ordered batches assignment v2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsAssignmentV2: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/entry-points/assignment-v2`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Data import ordered batches v2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsDataImportV2: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/management/entry-points/data-import-v2`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * OrderedBatchesApi - functional programming interface
 * @export
 */
export const OrderedBatchesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = OrderedBatchesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Create Ordered Batch
         * @param {OrderedBatchCreateRequest} [orderedBatchCreateRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createOrderedBatch(orderedBatchCreateRequest?: OrderedBatchCreateRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<OrderedBatch>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createOrderedBatch(orderedBatchCreateRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List Ordered Batches
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listOrderedBatches(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<OrderedBatch>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listOrderedBatches(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Order batches v2
         * @param {OrderBatchesV2Request} [orderBatchesV2Request] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async orderBatchesV2(orderBatchesV2Request?: OrderBatchesV2Request, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BatchesJob>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.orderBatchesV2(orderBatchesV2Request, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Ordered batches assignment v2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postManagementEntryPointsAssignmentV2(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postManagementEntryPointsAssignmentV2(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Data import ordered batches v2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async postManagementEntryPointsDataImportV2(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.postManagementEntryPointsDataImportV2(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * OrderedBatchesApi - factory interface
 * @export
 */
export const OrderedBatchesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = OrderedBatchesApiFp(configuration)
    return {
        /**
         * 
         * @summary Create Ordered Batch
         * @param {OrderedBatchCreateRequest} [orderedBatchCreateRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createOrderedBatch(orderedBatchCreateRequest?: OrderedBatchCreateRequest, options?: any): AxiosPromise<OrderedBatch> {
            return localVarFp.createOrderedBatch(orderedBatchCreateRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List Ordered Batches
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrderedBatches(options?: any): AxiosPromise<Array<OrderedBatch>> {
            return localVarFp.listOrderedBatches(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Order batches v2
         * @param {OrderBatchesV2Request} [orderBatchesV2Request] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        orderBatchesV2(orderBatchesV2Request?: OrderBatchesV2Request, options?: any): AxiosPromise<BatchesJob> {
            return localVarFp.orderBatchesV2(orderBatchesV2Request, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Ordered batches assignment v2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsAssignmentV2(options?: any): AxiosPromise<void> {
            return localVarFp.postManagementEntryPointsAssignmentV2(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Data import ordered batches v2
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        postManagementEntryPointsDataImportV2(options?: any): AxiosPromise<void> {
            return localVarFp.postManagementEntryPointsDataImportV2(options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * OrderedBatchesApi - object-oriented interface
 * @export
 * @class OrderedBatchesApi
 * @extends {BaseAPI}
 */
export class OrderedBatchesApi extends BaseAPI {
    /**
     * 
     * @summary Create Ordered Batch
     * @param {OrderedBatchCreateRequest} [orderedBatchCreateRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrderedBatchesApi
     */
    public createOrderedBatch(orderedBatchCreateRequest?: OrderedBatchCreateRequest, options?: AxiosRequestConfig) {
        return OrderedBatchesApiFp(this.configuration).createOrderedBatch(orderedBatchCreateRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List Ordered Batches
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrderedBatchesApi
     */
    public listOrderedBatches(options?: AxiosRequestConfig) {
        return OrderedBatchesApiFp(this.configuration).listOrderedBatches(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Order batches v2
     * @param {OrderBatchesV2Request} [orderBatchesV2Request] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrderedBatchesApi
     */
    public orderBatchesV2(orderBatchesV2Request?: OrderBatchesV2Request, options?: AxiosRequestConfig) {
        return OrderedBatchesApiFp(this.configuration).orderBatchesV2(orderBatchesV2Request, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Ordered batches assignment v2
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrderedBatchesApi
     */
    public postManagementEntryPointsAssignmentV2(options?: AxiosRequestConfig) {
        return OrderedBatchesApiFp(this.configuration).postManagementEntryPointsAssignmentV2(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Data import ordered batches v2
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof OrderedBatchesApi
     */
    public postManagementEntryPointsDataImportV2(options?: AxiosRequestConfig) {
        return OrderedBatchesApiFp(this.configuration).postManagementEntryPointsDataImportV2(options).then((request) => request(this.axios, this.basePath));
    }
}



